SoHandleBoxDragger Class Reference
Dragger Classes

The SoHandleBoxDragger class provides support for interactive scaling and translation. More...

`#include <Inventor/draggers/SoHandleBoxDragger.h>`

Inheritance diagram for SoHandleBoxDragger:

## Public Member Functions

virtual SoType | getTypeId (void) const
virtual const SoNodekitCatalog * | getNodekitCatalog (void) const
| SoHandleBoxDragger (void)
Public Member Functions inherited from SoDragger
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
void | setProjectorEpsilon (const float epsilon)
float | getProjectorEpsilon (void) const
void | addStartCallback (SoDraggerCB *func, void *data=NULL)
void | removeStartCallback (SoDraggerCB *func, void *data=NULL)
void | addMotionCallback (SoDraggerCB *func, void *data=NULL)
void | removeMotionCallback (SoDraggerCB *func, void *data=NULL)
void | addFinishCallback (SoDraggerCB *func, void *data=NULL)
void | removeFinishCallback (SoDraggerCB *func, void *data=NULL)
void | addValueChangedCallback (SoDraggerCB *func, void *data=NULL)
void | removeValueChangedCallback (SoDraggerCB *func, void *data=NULL)
void | setMinGesture (int pixels)
int | getMinGesture (void) const
SbBool | enableValueChangedCallbacks (SbBool newval)
const SbMatrix & | getMotionMatrix (void)
void | addOtherEventCallback (SoDraggerCB *func, void *data=NULL)
void | removeOtherEventCallback (SoDraggerCB *func, void *data=NULL)
void | registerChildDragger (SoDragger *child)
void | unregisterChildDragger (SoDragger *child)
void | registerChildDraggerMovingIndependently (SoDragger *child)
void | unregisterChildDraggerMovingIndependently (SoDragger *child)
SbMatrix | getLocalToWorldMatrix (void)
SbMatrix | getWorldToLocalMatrix (void)
SbVec3f | getLocalStartingPoint (void)
SbVec3f | getWorldStartingPoint (void)
void | getPartToLocalMatrix (const SbName &partname, SbMatrix &parttolocalmatrix, SbMatrix &localtopartmatrix)
void | transformMatrixLocalToWorld (const SbMatrix &frommatrix, SbMatrix &tomatrix)
void | transformMatrixWorldToLocal (const SbMatrix &frommatrix, SbMatrix &tomatrix)
void | transformMatrixToLocalSpace (const SbMatrix &frommatrix, SbMatrix &tomatrix, const SbName &fromspacepartname)
virtual void | setMotionMatrix (const SbMatrix &newmatrix)
void | valueChanged (void)
const SbMatrix & | getStartMotionMatrix (void)
virtual void | saveStartParameters (void)
const SoPath * | getPickPath (void) const
const SoEvent * | getEvent (void) const
SoPath * | createPathToThis (void)
const SoPath * | getSurrogatePartPickedOwner (void) const
const SbName & | getSurrogatePartPickedName (void) const
const SoPath * | getSurrogatePartPickedPath (void) const
void | setStartingPoint (const SoPickedPoint *newpoint)
void | setStartingPoint (const SbVec3f &newpoint)
const SbViewVolume & | getViewVolume (void)
void | setViewVolume (const SbViewVolume &vol)
const SbViewportRegion & | getViewportRegion (void)
void | setViewportRegion (const SbViewportRegion &reg)
SoHandleEventAction * | getHandleEventAction (void) const
void | setHandleEventAction (SoHandleEventAction *newAction)
void | setTempPathToThis (const SoPath *somethingclose)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
void | workFieldsIntoTransform (SbMatrix &mtx)
void | setFrontOnProjector (ProjectorFrontSetting newval)
ProjectorFrontSetting | getFrontOnProjector (void) const
Public Member Functions inherited from SoInteractionKit
| SoInteractionKit (void)
virtual SbBool | setPartAsPath (const SbName &partname, SoPath *path)
virtual SbBool | setPartAsDefault (const SbName &partname, SoNode *node, SbBool onlyifdefault=TRUE)
virtual SbBool | setPartAsDefault (const SbName &partname, const SbName &nodename, SbBool onlyifdefault=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path, SoPath *&pathToOwner, SbName &surrogatename, SoPath *&surrogatepath, SbBool fillargs=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path)
virtual SbBool | setPart (const SbName &partname, SoNode *from)
Public Member Functions inherited from SoBaseKit
| SoBaseKit (void)
virtual SoNode * | getPart (const SbName &partname, SbBool makeifneeded)
SbString | getPartString (const SoBase *part)
virtual SoNodeKitPath * | createPathToPart (const SbName &partname, SbBool makeifneeded, const SoPath *pathtoextend=NULL)
SbBool | set (const char *namevaluepairliststring)
SbBool | set (const char *partnamestring, const char *parameterstring)
virtual void | doAction (SoAction *action)
virtual SoChildList * | getChildren (void) const
void | printDiagram (void)
void | printSubDiagram (const SbName &rootname, int level)
void | printTable (void)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | forceChildDrivenWriteRefs (SoOutput *out)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
Static Public Member Functions inherited from SoDragger
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | setMinScale (float newminscale)
static float | getMinScale (void)
static void | workValuesIntoTransform (SbMatrix &mtx, const SbVec3f *translationptr, const SbRotation *rotationptr, const SbVec3f *scalefactorptr, const SbRotation *scaleorientationptr, const SbVec3f *centerptr)
static void | getTransformFast (SbMatrix &mtx, SbVec3f &translation, SbRotation &rotation, SbVec3f &scalefactor, SbRotation &scaleorientation, const SbVec3f &center)
static void | getTransformFast (SbMatrix &mtx, SbVec3f &translation, SbRotation &rotation, SbVec3f &scalefactor, SbRotation &scaleorientation)
static SbMatrix | appendTranslation (const SbMatrix &mtx, const SbVec3f &translation, const SbMatrix *conversion=NULL)
static SbMatrix | appendScale (const SbMatrix &mtx, const SbVec3f &scale, const SbVec3f &scalecenter, const SbMatrix *conversion=NULL)
static SbMatrix | appendRotation (const SbMatrix &mtx, const SbRotation &rot, const SbVec3f &rotcenter, const SbMatrix *conversion=NULL)
static void | initClass (void)
static void | initClasses (void)
Static Public Member Functions inherited from SoInteractionKit
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | setSwitchValue (SoNode *node, const int newVal)
Static Public Member Functions inherited from SoBaseKit
static SoType | getClassTypeId (void)
static void | initClass (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static SbBool | isSearchingChildren (void)
static void | setSearchingChildren (const SbBool newval)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFVec3f | scaleFactor
SoSFVec3f | translation
Public Attributes inherited from SoDragger
SoSFBool | isActive
Public Attributes inherited from SoInteractionKit
SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoHandleBoxDragger (void)
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | setDefaultOnNonWritingFields (void)
void | dragStart (void)
void | drag (void)
void | dragFinish (void)
void | setAllPartsActive (SbBool onoroff)
Protected Member Functions inherited from SoDragger
| SoDragger (void)
virtual | ~SoDragger (void)
SbVec2f | getNormalizedLocaterPosition (void)
SbVec2s | getLocaterPosition (void)
SbVec2s | getStartLocaterPosition (void) const
void | setStartLocaterPosition (SbVec2s p)
SbBool | isAdequateConstraintMotion (void)
virtual SbBool | shouldGrabBasedOnSurrogate (const SoPath *pickpath, const SoPath *surrogatepath)
void | setCameraInfo (SoAction *action)
virtual void | handleEvent (SoHandleEventAction *ha)
void | transferMotion (SoDragger *child)
void | setIgnoreInBbox (SbBool newval)
SbBool | isIgnoreInBbox (void)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
void | setActiveChildDragger (SoDragger *newchilddragger)
SoDragger * | getActiveChildDragger (void) const
void | updateDraggerCache (const SoPath *path)
virtual const SoPickedPoint * | getPickedPointForStart (SoHandleEventAction *action)
Protected Member Functions inherited from SoInteractionKit
virtual | ~SoInteractionKit ()
virtual void | copyContents (const SoFieldContainer *fromFC, SbBool copyConnections)
virtual SbBool | setPart (const int partNum, SoNode *node)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, SoNode *node, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, const SbName &nodename, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
SbBool | setAnySurrogatePath (const SbName &name, SoPath *path, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
void | connectSeparatorFields (SoSeparator *dest, SbBool onOff)
Protected Member Functions inherited from SoBaseKit
virtual | ~SoBaseKit ()
virtual SoNode * | addToCopyDict (void) const
SoGroup * | getContainerNode (const SbName &listname, SbBool makeifneeded=TRUE)
virtual SoNode * | getAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
virtual SoNodeKitPath * | createPathToAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE, const SoPath *pathtoextend=NULL)
virtual SbBool | setAnyPart (const SbName &partname, SoNode *from, SbBool anypart=TRUE)
void | createNodekitPartsList (void)
void | createFieldList (void)
virtual void | createDefaultParts (void)
const SoNodekitParts * | getNodekitPartsList (void) const
const SbList< SoSFNode * > & | getCatalogInstances (void) const
void | catalogError (void)
void | countMyFields (SoOutput *out)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | startCB (void *f, SoDragger *d)
static void | motionCB (void *f, SoDragger *d)
static void | finishCB (void *f, SoDragger *d)
static void | metaKeyChangeCB (void *f, SoDragger *d)
static void | fieldSensorCB (void *f, SoSensor *s)
static void | valueChangedCB (void *f, SoDragger *d)
Static Protected Member Functions inherited from SoDragger
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | childTransferMotionAndValueChangedCB (void *, SoDragger *)
static void | childValueChangedCB (void *, SoDragger *)
static void | childStartCB (void *, SoDragger *)
static void | childMotionCB (void *, SoDragger *)
static void | childFinishCB (void *, SoDragger *)
static void | childOtherEventCB (void *, SoDragger *)
Static Protected Member Functions inherited from SoInteractionKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | readDefaultParts (const char *fileName, const char defaultBuffer[], int defBufSize)
static void | fieldSensorCB (void *, SoSensor *)
Static Protected Member Functions inherited from SoBaseKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes

SoSFNode | arrow1
SoSFNode | arrow1Switch
SoSFNode | arrow2
SoSFNode | arrow2Switch
SoSFNode | arrow3
SoSFNode | arrow3Switch
SoSFNode | arrow4
SoSFNode | arrow4Switch
SoSFNode | arrow5
SoSFNode | arrow5Switch
SoSFNode | arrow6
SoSFNode | arrow6Switch
SoSFNode | arrowTranslation
SoSFNode | drawStyle
SoSFNode | extruder1
SoSFNode | extruder1Active
SoSFNode | extruder1Switch
SoSFNode | extruder2
SoSFNode | extruder2Active
SoSFNode | extruder2Switch
SoSFNode | extruder3
SoSFNode | extruder3Active
SoSFNode | extruder3Switch
SoSFNode | extruder4
SoSFNode | extruder4Active
SoSFNode | extruder4Switch
SoSFNode | extruder5
SoSFNode | extruder5Active
SoSFNode | extruder5Switch
SoSFNode | extruder6
SoSFNode | extruder6Active
SoSFNode | extruder6Switch
SoSFNode | surroundScale
SoSFNode | translator1
SoSFNode | translator1Active
SoSFNode | translator1Switch
SoSFNode | translator2
SoSFNode | translator2Active
SoSFNode | translator2Switch
SoSFNode | translator3
SoSFNode | translator3Active
SoSFNode | translator3Switch
SoSFNode | translator4
SoSFNode | translator4Active
SoSFNode | translator4Switch
SoSFNode | translator5
SoSFNode | translator5Active
SoSFNode | translator5Switch
SoSFNode | translator6
SoSFNode | translator6Active
SoSFNode | translator6Switch
SoSFNode | uniform1
SoSFNode | uniform1Active
SoSFNode | uniform1Switch
SoSFNode | uniform2
SoSFNode | uniform2Active
SoSFNode | uniform2Switch
SoSFNode | uniform3
SoSFNode | uniform3Active
SoSFNode | uniform3Switch
SoSFNode | uniform4
SoSFNode | uniform4Active
SoSFNode | uniform4Switch
SoSFNode | uniform5
SoSFNode | uniform5Active
SoSFNode | uniform5Switch
SoSFNode | uniform6
SoSFNode | uniform6Active
SoSFNode | uniform6Switch
SoSFNode | uniform7
SoSFNode | uniform7Active
SoSFNode | uniform7Switch
SoSFNode | uniform8
SoSFNode | uniform8Active
SoSFNode | uniform8Switch
SoFieldSensor * | translFieldSensor
SoFieldSensor * | scaleFieldSensor
Protected Attributes inherited from SoDragger
SoSFNode | motionMatrix
Protected Attributes inherited from SoInteractionKit
SoSFNode | geomSeparator
SoSFNode | topSeparator
SoFieldSensor * | fieldSensor
SoSeparator * | oldTopSep
Protected Attributes inherited from SoBaseKit
SoSFNode | callbackList
SoChildList * | children
SbBool | connectionsSetUp
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members

Public Types inherited from SoDragger
enum | ProjectorFrontSetting { FRONT , BACK , USE_PICK }
Public Types inherited from SoInteractionKit
enum | CacheEnabled { OFF , ON , AUTO }
Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoHandleBoxDragger class provides support for interactive scaling and translation.

Here's how the dragger looks with its default geometry in the inactive state:

Screen Shot of Default Dragger

A handle box dragger is convenient to use for letting the user interact with geometry that can be scaled (uniformly or in a non-uniform way) and translated in 3D.

The dragger consists of a "cube" of interaction geometry. The end-user can click and drag any side of the cube to translate the dragger and click and drag any of the corner or edge markers for scaling operations.

## Constructor & Destructor Documentation

## SoHandleBoxDragger()

SoHandleBoxDragger::SoHandleBoxDragger | ( | void |  | ) |

Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Nodekit structure (new entries versus parent class marked with arrow prefix):

    CLASS SoHandleBoxDragger
    -->"this"
          "callbackList"
          "topSeparator"
             "motionMatrix"
    -->      "surroundScale"
             "geomSeparator"
    -->         "drawStyle"
    -->         "translator1Switch"
    -->            "translator1"
    -->            "translator1Active"
    -->         "translator2Switch"
    -->            "translator2"
    -->            "translator2Active"
    -->         "translator3Switch"
    -->            "translator3"
    -->            "translator3Active"
    -->         "translator4Switch"
    -->            "translator4"
    -->            "translator4Active"
    -->         "translator5Switch"
    -->            "translator5"
    -->            "translator5Active"
    -->         "translator6Switch"
    -->            "translator6"
    -->            "translator6Active"
    -->         "extruder1Switch"
    -->            "extruder1"
    -->            "extruder1Active"
    -->         "extruder2Switch"
    -->            "extruder2"
    -->            "extruder2Active"
    -->         "extruder3Switch"
    -->            "extruder3"
    -->            "extruder3Active"
    -->         "extruder4Switch"
    -->            "extruder4"
    -->            "extruder4Active"
    -->         "extruder5Switch"
    -->            "extruder5"
    -->            "extruder5Active"
    -->         "extruder6Switch"
    -->            "extruder6"
    -->            "extruder6Active"
    -->         "uniform1Switch"
    -->            "uniform1"
    -->            "uniform1Active"
    -->         "uniform2Switch"
    -->            "uniform2"
    -->            "uniform2Active"
    -->         "uniform3Switch"
    -->            "uniform3"
    -->            "uniform3Active"
    -->         "uniform4Switch"
    -->            "uniform4"
    -->            "uniform4Active"
    -->         "uniform5Switch"
    -->            "uniform5"
    -->            "uniform5Active"
    -->         "uniform6Switch"
    -->            "uniform6"
    -->            "uniform6Active"
    -->         "uniform7Switch"
    -->            "uniform7"
    -->            "uniform7Active"
    -->         "uniform8Switch"
    -->            "uniform8"
    -->            "uniform8Active"
    -->         "arrowTranslation"
    -->         "arrow1Switch"
    -->            "arrow1"
    -->         "arrow2Switch"
    -->            "arrow2"
    -->         "arrow3Switch"
    -->            "arrow3"
    -->         "arrow4Switch"
    -->            "arrow4"
    -->         "arrow5Switch"
    -->            "arrow5"
    -->         "arrow6Switch"
    -->            "arrow6"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

    CLASS SoHandleBoxDragger
    PVT   "this",  SoHandleBoxDragger  ---
          "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
    PVT   "topSeparator",  SoSeparator  ---
    PVT   "motionMatrix",  SoMatrixTransform  ---
          "surroundScale",  SoSurroundScale  ---
    PVT   "geomSeparator",  SoSeparator  ---
    PVT   "drawStyle",  SoDrawStyle  ---
    PVT   "translator1Switch",  SoSwitch  ---
          "translator1",  SoSeparator  ---
          "translator1Active",  SoSeparator  ---
    PVT   "translator2Switch",  SoSwitch  ---
          "translator2",  SoSeparator  ---
          "translator2Active",  SoSeparator  ---
    PVT   "translator3Switch",  SoSwitch  ---
          "translator3",  SoSeparator  ---
          "translator3Active",  SoSeparator  ---
    PVT   "translator4Switch",  SoSwitch  ---
          "translator4",  SoSeparator  ---
          "translator4Active",  SoSeparator  ---
    PVT   "translator5Switch",  SoSwitch  ---
          "translator5",  SoSeparator  ---
          "translator5Active",  SoSeparator  ---
    PVT   "translator6Switch",  SoSwitch  ---
          "translator6",  SoSeparator  ---
          "translator6Active",  SoSeparator  ---
    PVT   "extruder1Switch",  SoSwitch  ---
          "extruder1",  SoSeparator  ---
          "extruder1Active",  SoSeparator  ---
    PVT   "extruder2Switch",  SoSwitch  ---
          "extruder2",  SoSeparator  ---
          "extruder2Active",  SoSeparator  ---
    PVT   "extruder3Switch",  SoSwitch  ---
          "extruder3",  SoSeparator  ---
          "extruder3Active",  SoSeparator  ---
    PVT   "extruder4Switch",  SoSwitch  ---
          "extruder4",  SoSeparator  ---
          "extruder4Active",  SoSeparator  ---
    PVT   "extruder5Switch",  SoSwitch  ---
          "extruder5",  SoSeparator  ---
          "extruder5Active",  SoSeparator  ---
    PVT   "extruder6Switch",  SoSwitch  ---
          "extruder6",  SoSeparator  ---
          "extruder6Active",  SoSeparator  ---
    PVT   "uniform1Switch",  SoSwitch  ---
          "uniform1",  SoSeparator  ---
          "uniform1Active",  SoSeparator  ---
    PVT   "uniform2Switch",  SoSwitch  ---
          "uniform2",  SoSeparator  ---
          "uniform2Active",  SoSeparator  ---
    PVT   "uniform3Switch",  SoSwitch  ---
          "uniform3",  SoSeparator  ---
          "uniform3Active",  SoSeparator  ---
    PVT   "uniform4Switch",  SoSwitch  ---
          "uniform4",  SoSeparator  ---
          "uniform4Active",  SoSeparator  ---
    PVT   "uniform5Switch",  SoSwitch  ---
          "uniform5",  SoSeparator  ---
          "uniform5Active",  SoSeparator  ---
    PVT   "uniform6Switch",  SoSwitch  ---
          "uniform6",  SoSeparator  ---
          "uniform6Active",  SoSeparator  ---
    PVT   "uniform7Switch",  SoSwitch  ---
          "uniform7",  SoSeparator  ---
          "uniform7Active",  SoSeparator  ---
    PVT   "uniform8Switch",  SoSwitch  ---
          "uniform8",  SoSeparator  ---
          "uniform8Active",  SoSeparator  ---
    PVT   "arrowTranslation",  SoTranslation  ---
    PVT   "arrow1Switch",  SoSwitch  ---
          "arrow1",  SoSeparator  ---
    PVT   "arrow2Switch",  SoSwitch  ---
          "arrow2",  SoSeparator  ---
    PVT   "arrow3Switch",  SoSwitch  ---
          "arrow3",  SoSeparator  ---
    PVT   "arrow4Switch",  SoSwitch  ---
          "arrow4",  SoSeparator  ---
    PVT   "arrow5Switch",  SoSwitch  ---
          "arrow5",  SoSeparator  ---
    PVT   "arrow6Switch",  SoSwitch  ---
          "arrow6",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

## ~SoHandleBoxDragger()

SoHandleBoxDragger::~SoHandleBoxDragger | ( | void |  | ) |

protected virtual

Protected destructor.

(Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

## getClassTypeId()

SoType SoHandleBoxDragger::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoHandleBoxDragger::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoDragger.

## getFieldDataPtr()

const SoFieldData ** SoHandleBoxDragger::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoHandleBoxDragger::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoDragger.

## getClassNodekitCatalog()

const SoNodekitCatalog * SoHandleBoxDragger::getClassNodekitCatalog | ( | void |  | ) |

static

Returns the nodekit catalog which defines the layout of this class' kit.

## getNodekitCatalog()

const SoNodekitCatalog * SoHandleBoxDragger::getNodekitCatalog | ( | void |  | ) | const

virtual

Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoDragger.

## getClassNodekitCatalogPtr()

const SoNodekitCatalog ** SoHandleBoxDragger::getClassNodekitCatalogPtr | ( | void |  | ) |

static protected

Returns the pointer to the pointer of the nodekit catalog for this class.

## initClass()

void SoHandleBoxDragger::initClass | ( | void |  | ) |

static

Initializes type system for this dragger class.

Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init().

## setUpConnections()

SbBool SoHandleBoxDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE )

protected virtual

Sets up all internal connections for instances of this class.

(This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.)

Reimplemented from SoInteractionKit.

## setDefaultOnNonWritingFields()

void SoHandleBoxDragger::setDefaultOnNonWritingFields | ( | void |  | ) |

protected virtual

(Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.)

This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scene graph export operations.

This is typically done when:

1. field value is `NULL` and part is `NULL` by default

2. it is a leaf SoGroup or SoSeparator node with no children

3. it is a leaf listpart with no children and an SoGroup or SoSeparator container

4. it is a non-leaf part and it is of SoGroup type and all fields are at their default values

Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method.

Reimplemented from SoDragger.

## startCB()

void SoHandleBoxDragger::startCB | ( | void * | f,
|  | SoDragger * | d )

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## motionCB()

void SoHandleBoxDragger::motionCB | ( | void * | f,
|  | SoDragger * | d )

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## finishCB()

void SoHandleBoxDragger::finishCB | ( | void * | f,
|  | SoDragger * | d )

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## metaKeyChangeCB()

void SoHandleBoxDragger::metaKeyChangeCB | ( | void * | f,
|  | SoDragger * | d )

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## fieldSensorCB()

void SoHandleBoxDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s )

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## valueChangedCB()

void SoHandleBoxDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d )

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## dragStart()

void SoHandleBoxDragger::dragStart | ( | void |  | ) |

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when dragger is selected (picked) by the user.

## drag()

void SoHandleBoxDragger::drag | ( | void |  | ) |

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when user drags the mouse after picking the dragger.

## dragFinish()

void SoHandleBoxDragger::dragFinish | ( | void |  | ) |

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when mouse button is released after picking and interacting with the dragger.

## setAllPartsActive()

void SoHandleBoxDragger::setAllPartsActive | ( | SbBool | onoroff | ) |

protected

Activate or deactivate all dragger geometry parts.

## Member Data Documentation

## scaleFactor

SoSFVec3f SoHandleBoxDragger::scaleFactor

Continuously updated to contain the current vector of scaling along the X, Y and Z axes.

## translation

SoSFVec3f SoHandleBoxDragger::translation

Continuously updated to contain the current translation from the dragger's local origo position.

The application programmer applying this dragger in his code should connect the relevant node fields in the scene to this field to make it follow the dragger.

## translFieldSensor

SoFieldSensor* SoHandleBoxDragger::translFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## scaleFieldSensor

SoFieldSensor* SoHandleBoxDragger::scaleFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoHandleBoxDragger.h
- SoHandleBoxDragger.cpp